#!/usr/bin/env zsh

set -e

echo "signing in to onepass"
op signin

export AWS_ACCESS_KEY_ID=$(op read op://personal/minio.front.kjuulh.io/username)
export AWS_SECRET_ACCESS_KEY=$(op read op://personal/minio.front.kjuulh.io/password)
export AWS_REGION=eu-west-1

if [[ $# -eq 0 ]]; then
    print "Usage: $0 [arguments...]"
    print "Please provide at least one argument"
    exit 1
fi

for arg in $@; do
  echo "building and uploading: $arg"

  lowercase_arg=${arg//-/_}

  echo "processing: $arg"

  echo "building rust project"
  (cd $arg && cargo component build --release)

  echo "upload"
  aws s3 cp $arg/target/wasm32-wasip1/release/$lowercase_arg.wasm s3://churn-registry/$lowercase_arg/0.1.0/$lowercase_arg.wasm --endpoint-url https://api-minio.front.kjuulh.io
done

